if not _G.VTKC then
    _G.VTKC = {}
	VTKC._path = ModPath
	VTKC.totalKills = { kills = 0, sessionKills = "on", flipped = "on", type = 1 }
	VTKC.neededKills = 658893
	function VTKC:Load()
		local  file = io.open(SavePath .. "TotalKills.json", "r")
		if not file   then return false end
		local  fileT= file:read("*all"):gsub("%[%]","{}") 
			   file : close()
		if 	   fileT == "" then return end
		
		VTKC.totalKills = json.decode(fileT)
	end
	VTKC:Load()

	function VTKC:Save()
		local  file = io.open(SavePath .. "TotalKills.json", "w")
		if not file then return false end
			   file:write(json.encode( VTKC.totalKills ))
			   file:close()
	end
	VTKC:Save()
end



Hooks:PostHook( HUDAssaultCorner, "init", "nephud_kill_panel_hud", function(self, data)
	VTKC:Load()
	VTKC._total_killed_in_session = 0

	local icons_panel = self._custom_hud_panel:child("icons_panel")
	local cuffed_panel = icons_panel:child("cuffed_panel")
	local panel_w, panel_h = 44 * self._scale, 38 * self._scale
	local is_level_ghostable = managers.job:is_level_ghostable(managers.job:current_level_id()) and managers.groupai and managers.groupai:state():whisper_mode()
	local highlight_texture = "guis/textures/VoidUI/hud_highlights"
	
	local sessionKillsAlpha = 1
	if VTKC.totalKills.sessionKills == "off" then
		sessionKillsAlpha = 0
	end
	local kills_panel = icons_panel:panel({
		name = "kills_panel",
		w = panel_w,
		h = panel_h,
		alpha = sessionKillsAlpha
	})

	local kills_panel2 = icons_panel:panel({
		name = "kills_panel2",
		w = panel_w,
		h = panel_h,
		alpha = 1
	})
	
	if VTKC.totalKills.sessionKills == "on" and VTKC.totalKills.flipped == "off" then
		kills_panel:set_right(cuffed_panel:left())
		kills_panel2:set_right(kills_panel:left())
	else
		kills_panel2:set_right(cuffed_panel:left())
		kills_panel:set_right(kills_panel2:left())
	end

	local kills_background = kills_panel:bitmap({
		name = "kills_background",
		texture = highlight_texture,
		texture_rect = {0,316,171,150},
		layer = 1,
		w = panel_w,
		h = panel_h,
		color = Color.black
	})

	local kills_border = kills_panel:bitmap({
		name = "kills_border",
		texture = highlight_texture,
		texture_rect = {172,316,171,150},
		layer = 2,
		w = panel_w,
		h = panel_h,
	})

	local num_kills = kills_panel:text({
		name = "num_kills",
		text = "0",
		valign = "center",
		vertical = "bottom",
		align = "right",
		w = panel_w / 1.2,
		h = panel_h,
		layer = 3,
		x = 0,
		y = 0,
		color = Color.white,
		font = "fonts/font_medium_shadow_mf",
		font_size = panel_h / 2
	})

	local kills_icon = kills_panel:bitmap({
		name = "kills_icon",
		texture = "guis/textures/pd2/crimenet_skull",
		valign = "top",
		alpha = 0.6,
		layer = 2,
		w = panel_w / 2.2,
		h = panel_h / 1.8,
		x = 0,
		y = 0
	})

	local kills_background2 = kills_panel2:bitmap({
		name = "kills_background2",
		texture = highlight_texture,
		texture_rect = {0,316,171,150},
		layer = 1,
		w = panel_w,
		h = panel_h,
		color = Color.black
	})

	local kills_border2 = kills_panel2:bitmap({
		name = "kills_border2",
		texture = highlight_texture,
		texture_rect = {172,316,171,150},
		layer = 2,
		w = panel_w,
		h = panel_h,
	})

	local numberToDisplay = 0
	if VTKC.totalKills.type == 1 then
		numberToDisplay = VTKC.totalKills.kills
	elseif VTKC.totalKills.type == 2 then
		numberToDisplay = VTKC.neededKills - VTKC.totalKills.kills
	else
		numberToDisplay = math.floor(VTKC.totalKills.kills*10000/VTKC.neededKills)/100
	end

	local num_kills2 = kills_panel2:text({
		name = "num_kills2",
		text = tostring(numberToDisplay),
		valign = "center",
		vertical = "bottom",
		align = "right",
		w = panel_w / 1.2,
		h = panel_h,
		layer = 3,
		x = 0,
		y = 0,
		color = Color.white,
		font = "fonts/font_medium_shadow_mf",
		font_size = panel_h / 2
	})

	local kills_icon2 = kills_panel2:bitmap({
		name = "kills_icon2",
		texture = "guis/textures/pd2/crimenet_skull",
		valign = "top",
		alpha = 0.6,
		layer = 2,
		w = panel_w / 2.2,
		h = panel_h / 1.8,
		x = 0,
		y = 0
	})

	kills_icon:set_center(kills_border:center())
	kills_icon2:set_center(kills_border2:center())
end)

function HUDAssaultCorner:_offset_hostage(is_offseted, hostage_panel, big_logo)
	local TOTAL_T = 0.18
	local icons_panel = self._custom_hud_panel:child("icons_panel")
	local wave_panel = self._custom_hud_panel:child("wave_panel")
	local cuffed_panel = icons_panel:child("cuffed_panel")
	local pagers_panel = icons_panel:child("pagers_panel")
	local kills_panel = icons_panel:child("kills_panel")
	local kills_panel2 = icons_panel:child("kills_panel2")
	local panel_right = icons_panel:right()
	local panel_y = icons_panel:y()
	local t = 0
	while TOTAL_T > t do
		local dt = coroutine.yield()
		t = math.min(t + dt, TOTAL_T)
		local lerp = t / TOTAL_T
		if is_offseted then 
			icons_panel:set_alpha(math.lerp(1,0,lerp))
			if wave_panel then wave_panel:set_alpha(math.lerp(1,0,lerp)) end
		else
			icons_panel:set_right(math.lerp(panel_right, self._custom_hud_panel:w(),lerp))
			icons_panel:set_y(math.lerp(panel_y, 0, lerp))
			hostage_panel:set_y(0)
			cuffed_panel:set_y(0)
			pagers_panel:set_y(0)
			kills_panel:set_y(0)
			kills_panel2:set_y(0)
			if wave_panel then 
				wave_panel:set_right(math.lerp(self._custom_hud_panel:w() - 75 * self._scale, self._custom_hud_panel:w() - 5 * self._scale,lerp))
				wave_panel:set_y(math.lerp(47 * self._scale, 0, lerp))
			end
		end
		if self._start_assault_after_hostage_offset and lerp > 0.4 then
			self._start_assault_after_hostage_offset = nil
			self:start_assault_callback()
		end
	end	
	if is_offseted then
		if big_logo then wait(0.6) end
		TOTAL_T = 0.3
		t = 0
		icons_panel:set_right(big_logo and self._custom_hud_panel:w() - 70 * self._scale or self._custom_hud_panel:w() - 2 * self._scale)
		icons_panel:set_y(big_logo and 47 * self._scale or 32 * self._scale)
		hostage_panel:set_y(-hostage_panel:h())
		cuffed_panel:set_y(-cuffed_panel:h() * 2 * self._scale)
		pagers_panel:set_y(-pagers_panel:h() * 2 * self._scale)
		kills_panel:set_y(-kills_panel:h() * 2 * self._scale)
		kills_panel2:set_y(-kills_panel2:h() * 2 * self._scale)
		if wave_panel then 
			wave_panel:set_right(big_logo and self._custom_hud_panel:w() - 75 * self._scale or self._custom_hud_panel:w() - 7 * self._scale)
			wave_panel:set_y(big_logo and 47 * self._scale or 32 * self._scale)
		end
		icons_panel:set_alpha(1)
		while TOTAL_T > t do
			local dt = coroutine.yield()
			t = math.min(t + dt, TOTAL_T)
			local lerp = t / TOTAL_T
			hostage_panel:set_y(math.lerp(-hostage_panel:h(),0,lerp))
			cuffed_panel:set_y(math.lerp(-cuffed_panel:h() * 2,0,lerp))
			pagers_panel:set_y(math.lerp(-pagers_panel:h() * 2,0,lerp))
			kills_panel:set_y(math.lerp(-kills_panel:h() * 2,0,lerp))
			kills_panel2:set_y(math.lerp(-kills_panel2:h() * 2,0,lerp))
			if wave_panel then wave_panel:set_alpha(math.lerp(0,1,lerp)) end
		end
	end
	icons_panel:set_alpha(1)
	self:whisper_mode_changed()
	if self._start_assault_after_hostage_offset then
		self._start_assault_after_hostage_offset = nil
		self:start_assault_callback()
	end
end

