if not _G.VTKC then
    _G.VTKC = {}
	VTKC._path = ModPath
    VTKC.totalKills = { kills = 0, sessionKills = "on", flipped = "on", type = 1 }
    VTKC.neededKills = 658893
	function VTKC:Load()
		local  file = io.open(SavePath .. "TotalKills.json", "r")
		if not file   then return false end
		local  fileT= file:read("*all"):gsub("%[%]","{}") 
			   file : close()
		if 	   fileT == "" then return end
		
		VTKC.totalKills = json.decode(fileT)
	end
	VTKC:Load()

	function VTKC:Save()
		local  file = io.open(SavePath .. "TotalKills.json", "w")
		if not file then return false end
			   file:write(json.encode( VTKC.totalKills ))
			   file:close()
	end
	VTKC:Save()
end
VTKC:Load()


---------------------------------------------- Localization ------------------------------------------------
Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_VTKC", function(loc)
	for _, filename in pairs(file.GetFiles(VTKC._path .. "loc/")) do
		local str = filename:match('^(.*).txt$')
		if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
			loc:load_localization_file(VTKC._path .. "loc/" .. filename)
			break
		end
	end

	loc:load_localization_file(VTKC._path .. "loc/english.txt", false)
end)

----------------------- Callbacks ----------------------- 
Hooks:Add("MenuManagerInitialize", "MenuManagerInitialize_VTKC", function(menu_manager)
	MenuCallbackHandler.VTKC_settings_changed_callback = function(this,item)
	-- 	local name = tostring(item._parameters["name"]):gsub("VTKC_","")
	-- 	VTKC.settings[name] = Utils:ToggleItemToBoolean(item)
        -- VTKC:Save()
	end
    
    MenuCallbackHandler.VTKC_current_total_kills_callback = function(this,item)
        VTKC.totalKills.kills = math.floor(item:value())
        item:set_value(math.floor(item:value()))
		VTKC:Save()
    end
    
    MenuCallbackHandler.VTKC_session_kills_callback = function(this,item)
        VTKC.totalKills.sessionKills = item:value()
		VTKC:Save()
    end
    
    MenuCallbackHandler.VTKC_flipped_callback = function(this,item)
        VTKC.totalKills.flipped = item:value()
		VTKC:Save()
    end
    
    MenuCallbackHandler.VTKC_counter_type_callback = function(this,item)
        VTKC.totalKills.type = item:value()
		VTKC:Save()
	end
end)

----------------------- Menu Creation ----------------------- 
Hooks:Add("MenuManagerSetupCustomMenus", "Base_SetupCustomMenus_Json_VTKC_menu", function( menu_manager, nodes )
	MenuHelper:NewMenu( "VTKC_menu" )
end)

Hooks:Add("MenuManagerBuildCustomMenus", "Base_BuildCustomMenus_Json_VTKC_menu", function( menu_manager, nodes )
	local parent_menu = "blt_options"
	local menu_id = "VTKC_menu"
	local menu_name = "VTKC_menu_title"
	local menu_desc = "VTKC_menu_desc"

	local data = {
		focus_changed_callback = nil,
		area_bg = nil,
	}
	nodes[menu_id] = MenuHelper:BuildMenu( menu_id, data )

	MenuHelper:AddMenuItem( nodes[parent_menu], menu_id, menu_name, menu_desc, nil )

end)

Hooks:Add("MenuManagerPopulateCustomMenus", "Base_PopulateCustomMenus_Json_VTKC_menu", function( menu_manager, nodes )
    VTKC:Load()
    MenuHelper:AddSlider({
        id = "VTKC_current_total_kills",
        title = "VTKC_current_total_kills_title",
        desc = "VTKC_current_total_kills_desc",
        callback = "VTKC_current_total_kills_callback",
        value = tostring(VTKC.totalKills.kills),
        min = 0,
        max = 1000000,
        step = 1,
        show_value = true,
        menu_id = "VTKC_menu",
    })

    VTKC.menuValue = false
    if VTKC.totalKills.sessionKills == "on" then VTKC.menuValue = true else VTKC.menuValue = false end
    MenuHelper:AddToggle({
        id = "VTKC_session_kills",
        title = "VTKC_session_kills_title",
        desc = "VTKC_session_kills_desc",
        callback = "VTKC_session_kills_callback",
        value = VTKC.menuValue,
        menu_id = "VTKC_menu",
    })

    if VTKC.totalKills.flipped == "on" then VTKC.menuValue = true else VTKC.menuValue = false end
    MenuHelper:AddToggle({
        id = "VTKC_flipped",
        title = "VTKC_flipped_title",
        desc = "VTKC_flipped_desc",
        callback = "VTKC_flipped_callback",
        value = VTKC.menuValue,
        menu_id = "VTKC_menu",
    })

    -- if VTKC.totalKills.type == 1 then VTKC.menuValue = 1 elseif VTKC.totalKills.type == 2 then VTKC.menuValue = 2 else VTKC.menuValue = 3 end
    MenuHelper:AddMultipleChoice({
        id = "VTKC_counter_type",
        title = "VTKC_counter_type_title",
        desc = "VTKC_counter_type_desc",
        callback = "VTKC_counter_type_callback",
        items = {
            "VTKC_counter_type_option_1",
            "VTKC_counter_type_option_2",
            "VTKC_counter_type_option_3"
        },
        -- value = 2,
        value = VTKC.totalKills.type,
        menu_id = "VTKC_menu",
    })
end)